program Project2;

uses
  sdl,math,
  sdlutils,
  windows,
  dialogs,
  sysutils,
  SDL_Image,forms;

{$R *.res}

var
 Screen,img : PSDL_Surface;
 event : TSDL_Event;
 done : boolean;
 plasma1 : array[0..255999] of uint8; //(640x400) must be the double of our screen
 plasma2 : array[0..255999] of uint8; //(640x400) must be the double of our screen

//Precalculate the plasma and save it in our plasma arrays
procedure calculateplasma();
var
x,y,dest : integer;
begin
 dest := 0;
 for y := 0 to 399 do
 begin
  for x := 0 to 639 do
  begin
   plasma1[dest] := trunc(21+64*(sin(hypot(200-y,320-x)/16)));
   plasma2[dest] := trunc(21+64 * sin(x/(37+15*cos(y/74)))* cos(y/(31+11*sin(x/57))));
   dest := dest + 1;
  end;
end;
end;

//Set the pallete, the pallete's r,g,b values must always lie within 0-255
//and the pallete's 1st color must mach the pallets last color
procedure setpallete(surface : PSDL_Surface);
var
 pallete : TSDL_Colorarray;
 teller : integer;
begin
 for teller := 0 to 255 do
 begin
  pallete[teller].r := trunc(100 + 64 * cos(teller * pi/128 + (sdl_getticks() shr 2 ) / 100));
  pallete[teller].g := trunc(100+ 64 * sin(teller * pi/128 + (sdl_getticks() shr 2) / 110));;
  pallete[teller].b := trunc(100- 64 * cos(teller * pi/128 + (sdl_getticks() shr 2) / 120));;
 end;
 sdl_setpalette(surface,SDL_Physpal,@pallete,0,256);
end;

Procedure DrawPlasma(Surface : PSDL_Surface);
var
 x1,x2,x3,y1,y2,y3,src1,src2,src3,x,y : integer;
 dest : uint32;
 pixel1,pixel2 : uint8; // We work in 8bit mode (256 colors = 1 byte= 8bit)
begin
 //Calculate the starting points for where we are going to copy the
 //plasma from the precalculated buffer
 //never exceed the width and height of our screen since we will copy
 //the screen size nr of bytes to the screen surface
 x1 := 160 + trunc(159 * cos((sdl_getticks() shr 4) / 100));
 x2 := 160 + trunc(159 * sin(-(sdl_getticks() shr 4) / 110));
 x3 := 160 + trunc(159 * sin(-(sdl_getticks() shr 4) / 120));
 y1 := 100 + trunc(99 * sin((sdl_getticks() shr 4) / 100));
 y2 := 100 + trunc(99 * cos(-(sdl_getticks() shr 4) /110));
 y3 := 100 + trunc(99 * cos(-(sdl_getticks() shr 4) /120));
 //Calculate the offset
 src1 := y1*640+x1;
 src2 := y2*640+x2;
 src3 := y3*640+x3;
 //Lock the surface since we are going to manipulate pixels
 SDL_LOCKSURFACE(Screen);
 dest := 0;
 //For every pixel copy the pixel from the plasma buffers to screen surface
 for y := 0 to 199 do
 begin
  for x := 0 to 319 do
  begin
   copymemory(addr(pixel1),ptr(uint32(img.pixels) + dest),img.format.BytesPerPixel);
   pixel2 :=plasma1[src1]+plasma2[src2]+plasma2[src3]+ pixel1;
   copymemory(ptr(uint32(screen.pixels) + dest),@pixel2,screen.format.BytesPerPixel);
   //increment to get to the next pixel
   dest := dest + 1;
   src1 := src1 +1;
   src2 := src2+1;
   src3 := src3+1;
  end;
  //increment with screenwidth to set the offset to the next line onscreen
   src1 := src1+320;
   src2 := src2+320;
   src3 := src3+320;
 end;
 //unlock the surface
 SDL_UNLOCKSURFACE(SCreen);
end;

begin
 if SDL_INIT(SDL_INIT_VIDEO or SDL_INIT_TIMER) >= 0 then
 begin
  screen := SDL_SetVideoMode(320,200,8,SDL_SWSURFACE);
  if screen <> nil then
  begin
   img := IMG_Load( pchar(extractfilepath(application.exename)+'willemssoft.png'));
   if img <> nil then
   begin
    img := SDL_DisplayFormat(img);
    SDL_ShowCursor(0);
    CalculatePlasma();
    SDL_WM_SetCaption('Willems Soft - Plasma Example','');
    done := false;
    while not done do
    begin
     while SDL_PollEvent(@event) > 0 do
     begin
      case event.type_ of
       SDL_QUITEV : done := true;
       SDL_KEYDOWN : done := true;
      end;
     end;
     setpallete(screen);
     drawplasma(screen);
     SDL_Flip(Screen);
    end;
    SDL_FreeSurface(Img);
   end
   else
    showmessage('Failed to Load willemssoft.png!');

   SDL_FReeSurface(screen);
  end
  else
   showmessage('Failed To Set Screen resolution 320x200x8 bits');
  SDL_Quit;
 end
 else
  showmessage('Failed To initialise SDL!');
end.
